from uuid import uuid4

from sqlalchemy.sql.expression import text

from ...test_02_classes.commons.utils_create import create_class
from .utils_check import DESC, NAME, REF_TYPE, get_centroid

CR_ID = "User"
CR_TYPE = "user"
REF_ID = "WSI"
NPP_C = 10.0
POINT = [100, 100]
LINE = [[100, 100], [200, 200]]
HEAD = [100, 100]
TAIL = [200, 200]
RADIUS = 100
WIDTH = 100
HEIGHT = 100
POLYGON = [[100, 100], [200, 100], [200, 200], [100, 200]]


INSERT_BASE_SQL = """
INSERT INTO a_annotations(
    type,
    name,
    description,
    creator_id,
    creator_type,
    reference_id,
    reference_type,
    npp_created,
    npp_viewing_min,
    npp_viewing_max,
    npp_viewing_min_query,
    npp_viewing_max_query,
    created_at,
    updated_at,
    is_locked,
    {type_columns},
    centroid,
    bounding_box
)
VALUES(
    :annot_type,
    :name,
    :description,
    :creator_id,
    :creator_type,
    :reference_id,
    :reference_type,
    :npp_created,
    :npp_viewing_min,
    :npp_viewing_max,
    :npp_viewing_min_query,
    :npp_viewing_max_query,
    current_timestamp,
    current_timestamp,
    :is_locked,
    {type_column_values},
    :centroid,
    :bounding_box
) RETURNING id;
"""


def create_point(
    conn, cr_id=CR_ID, cr_type=CR_TYPE, ref_id=REF_ID, npp_c=NPP_C, npp_v=None, point=None, cen=None, is_locked=False
):
    if not point:
        point = POINT

    if not cen:
        cen = point

    bounding_box = f"""
    {point[0]},
    {point[1]},
    {point[0]},
    {point[1]}
    """

    insert_statement = INSERT_BASE_SQL.format(type_columns="coordinates", type_column_values=":coordinates")

    result = conn.execute(
        text(insert_statement),
        annot_type="point",
        name=NAME,
        description=DESC,
        creator_id=cr_id,
        creator_type=cr_type,
        reference_id=ref_id,
        reference_type=REF_TYPE,
        npp_created=npp_c,
        npp_viewing_min=npp_v[0] if npp_v is not None else None,
        npp_viewing_max=npp_v[1] if npp_v is not None else None,
        npp_viewing_min_query=npp_v[0] if npp_v is not None else npp_c,
        npp_viewing_max_query=npp_v[1] if npp_v is not None else npp_c,
        is_locked=is_locked,
        coordinates=point,
        centroid=cen,
        bounding_box=bounding_box,
    ).first()

    return result["id"]


def create_point_with_classes(
    conn,
    cl_count,
    cr_id=CR_ID,
    cr_type=CR_TYPE,
    ref_id=REF_ID,
    npp_c=NPP_C,
    npp_v=None,
    point=None,
    cen=None,
    is_locked=False,
):
    a_id = create_point(conn, cr_id, cr_type, ref_id, npp_c, npp_v, point, cen, is_locked)

    for _ in range(cl_count):
        create_class(conn, a_id, cr_id, cr_type)

    return a_id


def create_point_with_classes_different_creator(
    conn,
    cl_count,
    cr_id=CR_ID,
    cr_type=CR_TYPE,
    ref_id=REF_ID,
    npp_c=NPP_C,
    npp_v=None,
    point=None,
    cen=None,
    is_locked=False,
):
    a_id = create_point(conn, cr_id, cr_type, ref_id, npp_c, npp_v, point, cen, is_locked)

    for _ in range(cl_count):
        create_class(conn, a_id, cr_id, cr_type)
        create_class(conn, a_id, uuid4(), cr_type)

    return a_id


def create_line(
    conn, cr_id=CR_ID, cr_type=CR_TYPE, ref_id=REF_ID, npp_c=NPP_C, npp_v=None, line=None, cen=None, is_locked=False
):
    if not line:
        line = LINE

    if not cen:
        cen = get_centroid("line", line=line)

    bounding_box = f"""
    {line[0][0]},
    {line[0][1]},
    {line[1][0]},
    {line[1][1]}
    """

    insert_statement = INSERT_BASE_SQL.format(type_columns="coordinates", type_column_values=":coordinates")

    result = conn.execute(
        text(insert_statement),
        annot_type="line",
        name=NAME,
        description=DESC,
        creator_id=cr_id,
        creator_type=cr_type,
        reference_id=ref_id,
        reference_type=REF_TYPE,
        npp_created=npp_c,
        npp_viewing_min=npp_v[0] if npp_v is not None else None,
        npp_viewing_max=npp_v[1] if npp_v is not None else None,
        npp_viewing_min_query=npp_v[0] if npp_v is not None else npp_c,
        npp_viewing_max_query=npp_v[1] if npp_v is not None else npp_c,
        is_locked=is_locked,
        coordinates=line,
        centroid=cen,
        bounding_box=bounding_box,
    ).first()

    return result["id"]


def create_arrow(
    conn,
    cr_id=CR_ID,
    cr_type=CR_TYPE,
    ref_id=REF_ID,
    npp_c=NPP_C,
    npp_v=None,
    head=None,
    tail=None,
    cen=None,
    is_locked=False,
):
    if not head:
        head = HEAD

    if not tail:
        tail = TAIL

    if not cen:
        cen = get_centroid("arrow", head=head, tail=tail)

    bounding_box = f"""
    {head[0]},
    {head[1]},
    {tail[0]},
    {tail[1]}
    """

    insert_statement = INSERT_BASE_SQL.format(type_columns="head,tail", type_column_values=":head,:tail")

    result = conn.execute(
        text(insert_statement),
        annot_type="arrow",
        name=NAME,
        description=DESC,
        creator_id=cr_id,
        creator_type=cr_type,
        reference_id=ref_id,
        reference_type=REF_TYPE,
        npp_created=npp_c,
        npp_viewing_min=npp_v[0] if npp_v is not None else None,
        npp_viewing_max=npp_v[1] if npp_v is not None else None,
        npp_viewing_min_query=npp_v[0] if npp_v is not None else npp_c,
        npp_viewing_max_query=npp_v[1] if npp_v is not None else npp_c,
        is_locked=is_locked,
        head=head,
        tail=tail,
        centroid=cen,
        bounding_box=bounding_box,
    ).first()

    return result["id"]


def create_circle(
    conn,
    cr_id=CR_ID,
    cr_type=CR_TYPE,
    ref_id=REF_ID,
    npp_c=NPP_C,
    npp_v=None,
    center=None,
    radius=RADIUS,
    cen=None,
    is_locked=False,
):
    if not center:
        center = POINT

    if not cen:
        cen = center

    bounding_box = f"""
    {center[0] - radius},
    {center[1] - radius},
    {center[0] + radius},
    {center[1] + radius}
    """

    insert_statement = INSERT_BASE_SQL.format(type_columns="center,radius", type_column_values=":center,:radius")

    result = conn.execute(
        text(insert_statement),
        annot_type="circle",
        name=NAME,
        description=DESC,
        creator_id=cr_id,
        creator_type=cr_type,
        reference_id=ref_id,
        reference_type=REF_TYPE,
        npp_created=npp_c,
        npp_viewing_min=npp_v[0] if npp_v is not None else None,
        npp_viewing_max=npp_v[1] if npp_v is not None else None,
        npp_viewing_min_query=npp_v[0] if npp_v is not None else npp_c,
        npp_viewing_max_query=npp_v[1] if npp_v is not None else npp_c,
        is_locked=is_locked,
        center=center,
        radius=radius,
        centroid=cen,
        bounding_box=bounding_box,
    ).first()

    return result["id"]


def create_rectangle(
    conn,
    cr_id=CR_ID,
    cr_type=CR_TYPE,
    ref_id=REF_ID,
    npp_c=NPP_C,
    npp_v=None,
    upper_left=None,
    width=WIDTH,
    height=HEIGHT,
    cen=None,
    is_locked=False,
):
    if not upper_left:
        upper_left = POINT

    if not cen:
        cen = get_centroid("rectangle", upper_left=upper_left, width=width, height=height)

    bounding_box = f"""
    {upper_left[0]},
    {upper_left[1]},
    {upper_left[0] + width},
    {upper_left[1] + height}
    """

    insert_statement = INSERT_BASE_SQL.format(
        type_columns="upper_left,width,height", type_column_values=":upper_left,:width,:height"
    )

    result = conn.execute(
        text(insert_statement),
        annot_type="rectangle",
        name=NAME,
        description=DESC,
        creator_id=cr_id,
        creator_type=cr_type,
        reference_id=ref_id,
        reference_type=REF_TYPE,
        npp_created=npp_c,
        npp_viewing_min=npp_v[0] if npp_v is not None else None,
        npp_viewing_max=npp_v[1] if npp_v is not None else None,
        npp_viewing_min_query=npp_v[0] if npp_v is not None else npp_c,
        npp_viewing_max_query=npp_v[1] if npp_v is not None else npp_c,
        is_locked=is_locked,
        upper_left=upper_left,
        width=width,
        height=height,
        centroid=cen,
        bounding_box=bounding_box,
    ).first()

    return result["id"]


def create_polygon(
    conn,
    cr_id=CR_ID,
    cr_type=CR_TYPE,
    ref_id=REF_ID,
    npp_c=NPP_C,
    npp_v=None,
    polygon=None,
    cen=None,
    is_locked=False,
):
    if not polygon:
        polygon = POLYGON

    if not cen:
        cen = get_centroid("polygon", points=polygon)

    x_coords = [x for x in [p[0] for p in polygon]]
    y_coords = [y for y in [p[1] for p in polygon]]
    bounding_box = f"""
    {min(x_coords)},
    {min(y_coords)},
    {max(x_coords)},
    {max(y_coords)}
    """

    insert_statement = INSERT_BASE_SQL.format(type_columns="coordinates", type_column_values=":coordinates")

    result = conn.execute(
        text(insert_statement),
        annot_type="polygon",
        name=NAME,
        description=DESC,
        creator_id=cr_id,
        creator_type=cr_type,
        reference_id=ref_id,
        reference_type=REF_TYPE,
        npp_created=npp_c,
        npp_viewing_min=npp_v[0] if npp_v is not None else None,
        npp_viewing_max=npp_v[1] if npp_v is not None else None,
        npp_viewing_min_query=npp_v[0] if npp_v is not None else npp_c,
        npp_viewing_max_query=npp_v[1] if npp_v is not None else npp_c,
        is_locked=is_locked,
        coordinates=polygon,
        centroid=cen,
        bounding_box=bounding_box,
    ).first()

    return result["id"]


def get_large_polygons():
    return {
        "ONE": {
            "name": "ONE",
            "type": "polygon",
            "creator_id": "ONE",
            "coordinates": [
                [6172, 11906],
                [6172, 11906],
                [5582, 12447],
                [5336, 12644],
                [5237, 12792],
                [5139, 12939],
                [4991, 13136],
                [4893, 13284],
                [4794, 13481],
                [4745, 13530],
                [4745, 13628],
                [4696, 13727],
                [4696, 13973],
                [4696, 14071],
                [4696, 14169],
                [4745, 14218],
                [4745, 14218],
                [4844, 14415],
                [4844, 14415],
                [4942, 14563],
                [5040, 14661],
                [5139, 14760],
                [5286, 14809],
                [5582, 14858],
                [5729, 14809],
                [6024, 14710],
                [6221, 14858],
                [6320, 15153],
                [6418, 15350],
                [6516, 15498],
                [6615, 15596],
                [6615, 15596],
                [6713, 15744],
                [6812, 15842],
                [6910, 15940],
                [7008, 16039],
                [7156, 16137],
                [7304, 16186],
                [7451, 16186],
                [7648, 15990],
                [7796, 15842],
                [7943, 15645],
                [8091, 15399],
                [8386, 14907],
                [8484, 14809],
                [8534, 14661],
                [8583, 14563],
                [8632, 14415],
                [8681, 14268],
                [8780, 14071],
                [8927, 13776],
                [9026, 13481],
                [9124, 13284],
                [9222, 13185],
                [9271, 13136],
                [9321, 13038],
                [9321, 12939],
                [9321, 12841],
                [9321, 12743],
                [9321, 12546],
                [9271, 12349],
                [9222, 12054],
                [9173, 11857],
                [9124, 11660],
                [9026, 11365],
                [8927, 11070],
                [8829, 10873],
                [8681, 10627],
                [8583, 10430],
                [8534, 10283],
                [8534, 10184],
                [8534, 10184],
                [8484, 10086],
                [8435, 10037],
                [8386, 9987],
                [8238, 9889],
                [8042, 9840],
                [7796, 9840],
                [7550, 9791],
                [7353, 9741],
                [7008, 9643],
                [6861, 9545],
                [6762, 9496],
                [6664, 9397],
                [6615, 9299],
                [6566, 9200],
                [6566, 9053],
                [6566, 8856],
                [6467, 8462],
                [6369, 8364],
                [6270, 8266],
                [6074, 8167],
                [5778, 8118],
                [5336, 8118],
                [4893, 8216],
                [4548, 8266],
                [4352, 8364],
                [4155, 8561],
                [4057, 8758],
                [3958, 9053],
                [3909, 9200],
                [3761, 9643],
                [3663, 9938],
                [3565, 10184],
                [3515, 10529],
                [3515, 10676],
                [3565, 10775],
                [3614, 10873],
                [3663, 10971],
                [3761, 11021],
                [3860, 11119],
                [3958, 11119],
                [4155, 11119],
                [4303, 11119],
                [4401, 11119],
                [4401, 11119],
                [4499, 11070],
                [4598, 11070],
                [4745, 11070],
                [4942, 11217],
                [5040, 11267],
                [5139, 11316],
                [5237, 11414],
                [5385, 11562],
                [5483, 11611],
                [5582, 11611],
                [5729, 11562],
                [5778, 11513],
                [5778, 11513],
                [5828, 11463],
                [5828, 11463],
                [5877, 11513],
                [5877, 11513],
                [5877, 11660],
                [5926, 11759],
                [5975, 11808],
                [5975, 11808],
                [5975, 11906],
                [5975, 12054],
            ],
            "description": None,
            "npp_created": 24549.732620320854,
            "npp_viewing": None,
            "creator_type": "user",
            "reference_id": "f985bd96-0f96-41bb-a3ce-af9f04d460f8",
            "reference_type": "wsi",
        },
        "TWO": {
            "name": "TWO",
            "type": "polygon",
            "creator_id": "TWO",
            "coordinates": [
                [12420, 11217],
                [12420, 11217],
                [12420, 11316],
                [12420, 11365],
                [12371, 11611],
                [12273, 11709],
                [12223, 11808],
                [12125, 11906],
                [12027, 12005],
                [11928, 12152],
                [11879, 12251],
                [11879, 12349],
                [11879, 12447],
                [11928, 12595],
                [12076, 12792],
                [12519, 12939],
                [12912, 12939],
                [13306, 12939],
                [13847, 12595],
                [13945, 12398],
                [13994, 12103],
                [13798, 11562],
                [13650, 11513],
                [13552, 11513],
                [13453, 11660],
                [13404, 11808],
                [13355, 12103],
                [13404, 12398],
                [13503, 12546],
                [13748, 12841],
                [13994, 12841],
                [14240, 12792],
                [14486, 12644],
                [14782, 12398],
                [15028, 12103],
                [15323, 11513],
                [15618, 10873],
                [15667, 10775],
                [15716, 10775],
                [16061, 11021],
                [16454, 11070],
                [16946, 10971],
                [17488, 10725],
                [17832, 10332],
                [17930, 9594],
                [17734, 9004],
                [17340, 8512],
                [16700, 8069],
                [16061, 7872],
                [15470, 7724],
                [14880, 7626],
                [14732, 7626],
                [14732, 7675],
                [14782, 7724],
                [14782, 7724],
                [15028, 7626],
                [15126, 7528],
                [15126, 7429],
                [14978, 7183],
                [14585, 6937],
                [13158, 6740],
                [12076, 6740],
                [11338, 6839],
                [11092, 6888],
                [10747, 7036],
                [10698, 7183],
                [10747, 7429],
                [10895, 7823],
                [11043, 7921],
                [11289, 8020],
                [11535, 8020],
                [11682, 7970],
                [11781, 7823],
                [11830, 7626],
                [11682, 7232],
                [10895, 6986],
                [10255, 7036],
                [9862, 7282],
                [9271, 7970],
                [8730, 9102],
                [8681, 9692],
                [8829, 10086],
                [9075, 10381],
                [9321, 10479],
                [9468, 10479],
                [9567, 10479],
                [9714, 10725],
                [9960, 10873],
                [10354, 10971],
                [10747, 11021],
                [11141, 11021],
                [11535, 11070],
                [11879, 11119],
                [11977, 11168],
                [12125, 11267],
                [12223, 11267],
                [12273, 11365],
                [12371, 11414],
                [12469, 11463],
                [12617, 11513],
                [12715, 11562],
                [12765, 11562],
                [12814, 11513],
                [12863, 11414],
                [12961, 11316],
                [13011, 11267],
                [12961, 11217],
                [12912, 11168],
                [12715, 11168],
            ],
            "description": None,
            "npp_created": 24549.732620320854,
            "npp_viewing": None,
            "creator_type": "user",
            "reference_id": "f985bd96-0f96-41bb-a3ce-af9f04d460f8",
            "reference_type": "wsi",
        },
        "THREE": {
            "name": "THREE",
            "type": "polygon",
            "creator_id": "THREE",
            "coordinates": [
                [16159, 14268],
                [16159, 14268],
                [16110, 14366],
                [16061, 14415],
                [16012, 14612],
                [15962, 14661],
                [15913, 14760],
                [15815, 14858],
                [15716, 14956],
                [15618, 15006],
                [15520, 15104],
                [15126, 15252],
                [15028, 15350],
                [14929, 15350],
                [14880, 15399],
                [14880, 15399],
                [14831, 15498],
                [14732, 15547],
                [14683, 15645],
                [14634, 15744],
                [14585, 15793],
                [14585, 15940],
                [14585, 16039],
                [14634, 16137],
                [14732, 16236],
                [14929, 16285],
                [15126, 16383],
                [15323, 16432],
                [15421, 16432],
                [15569, 16432],
                [16012, 16285],
                [16159, 16186],
                [16208, 16137],
                [16208, 16137],
                [16258, 16088],
                [16356, 15891],
                [16356, 15793],
                [16356, 15694],
                [16356, 15596],
                [16307, 15498],
                [16307, 15448],
                [16307, 15448],
                [16307, 15350],
                [16356, 15301],
                [16405, 15301],
                [16454, 15252],
                [16602, 15153],
                [16651, 15202],
                [16651, 15202],
                [16750, 15350],
                [16799, 15448],
                [16799, 15498],
                [16848, 15694],
                [16848, 15793],
                [16848, 15842],
                [16848, 15990],
                [16848, 16088],
                [16848, 16186],
                [16897, 16383],
                [16946, 16432],
                [16946, 16531],
                [16946, 16531],
                [16946, 16678],
                [16946, 16777],
                [16946, 16875],
                [16946, 16875],
                [16946, 16974],
                [16946, 17072],
                [16996, 17121],
                [17094, 17170],
                [17192, 17220],
                [17340, 17170],
                [17537, 17072],
                [17586, 17023],
                [17684, 16924],
                [17783, 16826],
                [17881, 16728],
                [17930, 16580],
                [17980, 16482],
                [17980, 16334],
                [17980, 16186],
                [17980, 16137],
                [17881, 15990],
                [17881, 15940],
                [17783, 15842],
                [17684, 15744],
                [17488, 15547],
                [17389, 15547],
                [17291, 15498],
                [17192, 15498],
                [17192, 15498],
                [17192, 15448],
                [17242, 15399],
                [17389, 15252],
                [17537, 15153],
                [17684, 15104],
                [17832, 15055],
                [18127, 15006],
                [18373, 15006],
                [18767, 15006],
                [18865, 15055],
                [18914, 15055],
                [18914, 15055],
                [19013, 15055],
                [19062, 15055],
                [19062, 15055],
                [19160, 15006],
                [19160, 14809],
                [19160, 14661],
                [19062, 14563],
                [18963, 14464],
                [18865, 14366],
                [18767, 14268],
                [18668, 14169],
                [18521, 14022],
                [18471, 13973],
                [18275, 13923],
                [18275, 13923],
                [18127, 13923],
                [18127, 13923],
                [18029, 13973],
                [18029, 13973],
                [17930, 14022],
                [17881, 14022],
                [17832, 14120],
                [17783, 14169],
                [17734, 14218],
                [17684, 14268],
                [17586, 14317],
                [17537, 14366],
                [17537, 14366],
                [17488, 14415],
                [17537, 14366],
                [17635, 14268],
                [17684, 14169],
                [17734, 14022],
                [17734, 13874],
                [17783, 13727],
                [17832, 13579],
                [17881, 13431],
                [17930, 13284],
                [17930, 13185],
                [17930, 12989],
                [17930, 12989],
                [17930, 12841],
                [17930, 12841],
                [17832, 12693],
                [17783, 12644],
                [17684, 12595],
                [17586, 12595],
                [17438, 12595],
                [17389, 12595],
                [17389, 12595],
                [17291, 12644],
                [17192, 12693],
                [17094, 12792],
                [16996, 12890],
                [16897, 12939],
                [16897, 12939],
                [16848, 13038],
                [16799, 13185],
                [16799, 13333],
                [16799, 13431],
                [16750, 13579],
                [16750, 13677],
                [16750, 13776],
                [16750, 13874],
                [16750, 13874],
                [16750, 14022],
                [16750, 14022],
                [16750, 14169],
                [16750, 14268],
                [16750, 14268],
                [16750, 14415],
                [16750, 14415],
                [16750, 14317],
                [16750, 14169],
                [16750, 13973],
                [16700, 13923],
                [16602, 13677],
                [16553, 13579],
                [16504, 13530],
                [16454, 13481],
                [16405, 13431],
                [16356, 13431],
                [16356, 13431],
                [16208, 13382],
                [16159, 13382],
                [16061, 13382],
                [16061, 13382],
                [16012, 13431],
                [16012, 13431],
                [15913, 13431],
                [15716, 13579],
                [15716, 13579],
                [15716, 13677],
                [15716, 13776],
                [15815, 13923],
                [15815, 13923],
                [15864, 14022],
                [15913, 14071],
                [15913, 14169],
                [15962, 14169],
                [16012, 14218],
                [16110, 14218],
                [16159, 14268],
                [16208, 14218],
            ],
            "description": None,
            "npp_created": 24549.732620320854,
            "npp_viewing": None,
            "creator_type": "user",
            "reference_id": "f985bd96-0f96-41bb-a3ce-af9f04d460f8",
            "reference_type": "wsi",
        },
        "FOUR": {
            "name": "FOUR",
            "type": "polygon",
            "creator_id": "FOUR",
            "coordinates": [
                [16061, 18105],
                [16110, 18204],
                [16208, 18302],
                [16307, 18400],
                [16553, 18548],
                [16651, 18646],
                [16700, 18696],
                [16750, 18794],
                [16750, 18892],
                [16750, 18991],
                [16750, 18991],
                [16700, 19089],
                [16651, 19187],
                [16553, 19286],
                [16454, 19384],
                [16405, 19433],
                [16356, 19483],
                [16258, 19630],
                [16208, 19679],
                [16208, 19679],
                [16110, 19778],
                [16012, 19925],
                [16012, 19975],
                [15962, 20024],
                [15913, 20122],
                [15815, 20221],
                [15815, 20368],
                [15815, 20516],
                [15815, 20614],
                [15815, 20713],
                [15815, 20762],
                [15815, 20860],
                [15766, 20959],
                [15667, 21057],
                [15569, 21205],
                [15421, 21303],
                [15224, 21401],
                [14978, 21549],
                [14880, 21647],
                [14782, 21697],
                [14683, 21795],
                [14634, 21844],
                [14536, 21893],
                [14486, 21992],
                [14486, 22090],
                [14388, 22189],
                [14339, 22287],
                [14240, 22385],
                [14191, 22435],
                [14142, 22484],
                [14044, 22582],
                [13945, 22631],
                [13798, 22582],
                [13699, 22484],
                [13601, 22287],
                [13503, 22090],
                [13404, 21992],
                [13355, 21893],
                [13355, 21795],
                [13306, 21647],
                [13306, 21647],
                [13306, 21500],
                [13404, 21401],
                [13503, 21303],
                [13650, 21155],
                [13748, 20959],
                [13798, 20860],
                [13896, 20713],
                [14044, 20516],
                [14142, 20270],
                [14142, 20171],
                [14142, 20024],
                [14142, 20024],
                [14142, 19925],
                [14142, 19925],
                [14044, 19827],
                [14044, 19729],
                [14093, 19679],
                [14191, 19581],
                [14240, 19483],
                [14142, 19433],
                [14044, 19335],
                [13896, 19286],
                [13748, 19286],
                [13552, 19286],
                [13552, 19286],
                [13404, 19286],
                [13355, 19335],
                [13355, 19335],
                [13207, 19433],
                [13207, 19483],
                [13207, 19483],
                [13158, 19581],
                [13158, 19630],
                [13158, 19729],
                [13011, 19778],
                [12961, 19827],
                [12814, 19876],
                [12617, 19975],
                [12617, 19975],
                [12617, 20073],
                [12666, 19925],
                [12666, 19925],
                [12666, 19925],
                [12666, 19925],
                [12568, 19975],
                [12371, 20024],
                [12273, 20024],
                [12174, 20122],
                [12174, 20122],
                [11977, 20171],
                [11928, 20221],
                [11731, 20368],
                [11633, 20467],
                [11535, 20565],
                [11485, 20663],
                [11387, 20811],
                [11239, 21106],
                [11190, 21303],
                [11092, 21549],
                [11092, 21746],
                [11092, 21746],
                [11141, 21992],
                [11239, 22090],
                [11239, 22090],
                [11092, 22189],
                [10846, 22287],
                [10551, 22336],
                [10452, 22385],
                [9960, 22533],
                [9813, 22631],
                [9665, 22730],
                [9567, 22828],
                [12961, 23960],
                [13011, 23664],
                [13011, 23468],
                [13011, 23320],
                [12961, 23123],
                [12912, 23074],
                [12715, 22730],
                [12617, 22631],
                [12568, 22484],
                [12519, 22385],
                [12469, 22238],
                [12568, 22139],
                [12666, 22090],
                [12814, 22090],
                [12961, 22090],
                [13060, 22139],
                [13158, 22238],
                [13207, 22336],
                [13257, 22435],
                [13404, 22631],
                [13404, 22631],
                [13503, 22681],
                [13552, 22631],
                [13552, 22631],
                [13650, 22533],
                [13748, 22484],
                [13896, 22435],
                [13994, 22385],
                [14142, 22435],
                [14290, 22533],
                [14634, 22681],
                [14978, 22828],
                [15126, 22976],
                [15224, 23074],
                [15274, 23222],
                [15323, 23320],
                [15323, 23418],
                [15372, 23468],
                [15421, 23566],
                [15470, 23664],
                [15618, 23812],
                [16012, 23960],
                [16307, 24009],
                [16602, 24009],
                [16848, 24009],
                [16946, 24009],
                [16946, 24009],
                [16946, 23714],
                [16897, 23517],
                [16651, 22976],
                [16602, 22877],
                [16602, 22730],
                [16553, 22631],
                [16553, 22533],
                [16602, 22435],
                [16700, 22336],
                [16750, 22336],
                [17045, 22287],
                [17537, 22336],
                [18029, 22385],
                [18226, 22435],
                [18619, 22484],
                [18865, 22484],
                [18767, 22238],
                [18521, 21992],
                [18373, 21795],
                [18176, 21647],
                [18078, 21549],
                [17980, 21451],
                [17930, 21352],
                [17881, 21303],
                [17783, 21303],
                [17586, 21303],
                [17488, 21401],
                [17389, 21500],
                [17291, 21598],
                [17192, 21697],
                [17192, 21697],
                [17045, 21647],
                [16799, 21549],
                [16700, 21451],
                [16651, 21303],
                [16848, 20909],
                [17291, 20614],
                [17930, 20319],
                [18471, 20171],
                [18865, 20024],
                [18963, 19876],
                [18963, 19778],
                [18865, 19679],
                [18767, 19581],
                [18668, 19433],
                [18570, 19335],
                [18570, 19237],
                [18521, 19138],
                [18422, 18991],
                [18373, 18892],
                [18324, 18794],
                [18176, 18646],
                [18029, 18499],
                [17881, 18450],
                [17734, 18450],
                [17537, 18450],
                [17438, 18450],
                [17291, 18450],
                [17045, 18400],
                [16700, 18351],
                [16504, 18351],
                [16405, 18351],
                [16405, 18351],
                [16356, 18253],
                [16307, 18154],
                [15323, 17318],
                [15470, 17416],
                [15569, 17515],
                [15667, 17613],
                [15766, 17712],
                [15864, 17810],
                [16012, 17958],
            ],
            "description": None,
            "npp_created": 24549.732620320854,
            "npp_viewing": None,
            "creator_type": "user",
            "reference_id": "f985bd96-0f96-41bb-a3ce-af9f04d460f8",
            "reference_type": "wsi",
        },
        "FIVE": {
            "name": "FIVE",
            "type": "polygon",
            "creator_id": "FIVE",
            "coordinates": [
                [11604, 16557],
                [11573, 16698],
                [11557, 16870],
                [11557, 16995],
                [11557, 17121],
                [11604, 17371],
                [11620, 17465],
                [11667, 17684],
                [11761, 17904],
                [11964, 18232],
                [12215, 18530],
                [12418, 18733],
                [12481, 18780],
                [12716, 18890],
                [12794, 18906],
                [13076, 18906],
                [13170, 18859],
                [13499, 18733],
                [13593, 18671],
                [13812, 18467],
                [13984, 18217],
                [14094, 18029],
                [14125, 17794],
                [14109, 17716],
                [14031, 17465],
                [13984, 17371],
                [13921, 17199],
                [13796, 16948],
                [13749, 16870],
                [13593, 16620],
                [13530, 16557],
                [13342, 16369],
                [13280, 16322],
                [13060, 16181],
                [12966, 16134],
                [12763, 16040],
                [12418, 15946],
                [12324, 15931],
                [12137, 15899],
                [11996, 15899],
                [11870, 15884],
                [11745, 15899],
                [11589, 15962],
                [11495, 16009],
                [11463, 16040],
                [11416, 16134],
                [11385, 16228],
                [11338, 16385],
                [11338, 16698],
                [11354, 16745],
                [11385, 16823],
                [11385, 16823],
                [11385, 16870],
            ],
            "description": None,
            "npp_created": 7812.762763585163,
            "npp_viewing": None,
            "creator_type": "user",
            "reference_id": "f985bd96-0f96-41bb-a3ce-af9f04d460f8",
            "reference_type": "wsi",
        },
    }
